version: 0.2

env:
  variables:
    CPU: "256"
    DOCKER_IMAGE_TAG: "latest"
    FAMILY: "my-app"
    MEMORY: "512"

phases:
  pre_build:
    commands:
      - if [ ! "$AWS_ACCOUNT_ID" ]; then echo "Environment variable AWS_ACCOUNT_ID (e.g. 123456789012) was not found!" && exit 1; fi
      - if [ ! "$AWS_REGISTRY_HOST" ]; then echo "Environment variable AWS_REGISTRY_HOST (e.g. 123456789012.dkr.ecr.us-east-1.amazonaws.com) was not found!" && exit 1; fi
      - if [ ! "$CONTAINER_PORT" ]; then echo "Environment variable CONTAINER_PORT (e.g. 80) was not found!" && exit 1; fi
      - if [ ! "$DOCKER_IMAGE_NAME" ]; then echo "Environment variable DOCKER_IMAGE_NAME was not found!" && exit 1; fi
  build:
    commands:
      - docker build -t $AWS_REGISTRY_HOST/$DOCKER_IMAGE_NAME:$DOCKER_IMAGE_TAG .
  post_build:
    commands:
      - $(aws ecr get-login --no-include-email --registry-ids `echo $AWS_REGISTRY_HOST |cut -d '.' -f1` --region $AWS_REGION)
      - docker push $AWS_REGISTRY_HOST/$DOCKER_IMAGE_NAME:$DOCKER_IMAGE_TAG
      - export DOCKER_IMAGE="$(docker inspect --format='{{index .RepoDigests 0}}' $AWS_REGISTRY_HOST/$DOCKER_IMAGE_NAME:$DOCKER_IMAGE_TAG)"
      - sed -i "s,__AWS_ACCOUNT_ID__,$AWS_ACCOUNT_ID,g" taskdef.json
      - sed -i "s,__AWS_REGION__,$AWS_REGION,g" taskdef.json
      - sed -i "s,__COMMIT_SHA__,$CODEBUILD_RESOLVED_SOURCE_VERSION,g" taskdef.json
      - sed -i "s,__CONTAINER_PORT__,$CONTAINER_PORT,g" appspec.yaml taskdef.json
      - sed -i "s,__CPU__,$CPU,g" taskdef.json
      - sed -i "s,__DOCKER_IMAGE__,$DOCKER_IMAGE,g" taskdef.json
      - sed -i "s,__FAMILY__,$FAMILY,g" appspec.yaml taskdef.json
      - sed -i "s,__MEMORY__,$MEMORY,g" taskdef.json

artifacts:
  files:
    - taskdef.json
    - appspec.yaml
